import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Clase que representa el boton de reset, el cual regresa el estado original 
 * sin modificacion del laberinto actual.
 * 
 * @author Jaime Vazquez Castillo
 * @version 05082010
 */
public class Reset  extends Button
{
    /**
     * Act - Verifica presion en el boton reset maze.
     * This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(Greenfoot.mousePressed(this))
        {
            Greenfoot.playSound("click.wav");
            setImage("b_resetA.png");
        }
        if(Greenfoot.mouseClicked(this))
        {
            reset();
            setImage("b_reset.png");
        }
    }    
    
    /**
     *  Envia mensaje al explorador y momia de reset()
     */
    public void reset()
    {
        Explorer auxE;
        Mummy auxM;
        List aux;
        
        aux = getWorld().getObjects(Explorer.class);
        if(!aux.isEmpty())
        {
            auxE = (Explorer) aux.get(0);
            auxE.reset();
        }
        
        aux = getWorld().getObjects(Mummy.class);
        if(!aux.isEmpty())
        {
            auxM = (Mummy) aux.get(0);
            auxM.reset();
        }
    }
    
}
