import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Clase que representa la salida del laberinto en caso de que el explorador llegue
 * sin antes ser atrapado por la momia, pasa al siguiente laberinto.
 * 
 * @author Jaime Vazquez Castillo 
 * @version 04082010
 */
public class Stairs  extends Scenario
{
    private int x;
    private int y;
    private Explorer exp;
    private Mummy mum;
    private boolean isHere;
    private boolean passed;

    /**
     * Constructor para inicializar las variables de posicion de salida.
     * @param x coordenada en x que el explorador tiene que igualar para salir del laberinto.
     * @param y coordenada en y que el explorador tiene que igualar para salir del laberinto.
     * @param e referencia al explorador (jugador).
     * @param m referencia a la momia.
     */
    public Stairs(int x, int y, Explorer e, Mummy m)
    {
        this.x = x;
        this.y = y;
        exp = e;
        mum = m;
        passed = false;
        isHere = false;
        
        if(x==0) setImage("stairsL.png");
        else if(x==5) setImage("stairsR.png");
        else if(y==0) setImage("stairsU.png");
        else if(y==5) setImage("stairsD.png");
        
    }
    
    /**
     * Act - revisa si el explorador llego libre a la salida.
     * This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(isHere && !passed)
        {
            Greenfoot.playSound("finishedlevel.wav");
            if( x == 0 )
            {
                exp.moveLeft();
                //exp.moveLeft();
            }
            else if( x == 5 )
            {
                exp.moveRight();
                //exp.moveRight();
            }
            else if( y == 0 )
            {
                exp.moveUp();
                exp.moveUp();
            }
            else if( y == 5 )
            {
                exp.moveDown();
                exp.moveDown();
            }
            passed = true;
        }
        
        if(exp.x() == mum.x() && exp.y() == mum.y())
        {
            
        }
        else if(exp.x() == x && exp.y() == y)
            isHere = true;
    }
    
    /**
     * Avisa que el explorador resolvio el laberinto.
     * @return verdadero si escapo falso si no.
     */
    public boolean escaped()
    {
        return passed;
    }
}
